--[[
	DrunkardSK.lua
		Drunkard Suicide Kings
--]]

DrunkardSK = LibStub("AceAddon-3.0"):NewAddon("DrunkardSK", "AceConsole-3.0", "AceHook-3.0", "AceComm-3.0", "AceSerializer-3.0",  "AceEvent-3.0")

DrunkardSK.bg = {
	bgFile = 'Interface\\DialogFrame\\UI-DialogBox-Background',
	edgeFile = 'Interface\\DialogFrame\\UI-DialogBox-Border',
	insets = {left = 11, right = 11, top = 12, bottom = 11},
	tile = true,
	tileSize = 32,
	edgeSize = 32,
}

--master globals
local Master = false;
local ItemLink = nil
local HighRank = 5000
local HighName = ""
local BidsReceived = 0
local BidList = {}
local OffspecList = {}
local OffspecCount = 0
local HighRoller = "" 
local HighRoll = 0

--other globals
local EntrySelected = nil
local MyBidType = ""



--on mouseover of openlist button
local function OpenListEnter(self)
	GameTooltip:SetOwner(self, "ANCHOR_NONE")
    GameTooltip:SetPoint("BOTTOMLEFT", self, "TOPRIGHT")
    GameTooltip:SetText("View Lists")
    GameTooltip:Show()
end

--no more mouseover of openlist button
local function OpenListLeave()
	GameTooltip:Hide()
end

--suicide entry
local function Suicide(entry, list)
	local suicider = entry;
	local current = entry + 1;
	
	if(list == "nList") then
		if (current < DrunkardSK.db.realm.nLength) then
			for i=current, DrunkardSK.db.realm.nLength, 1 do
				--DrunkardSK:Print("Suicide --"..DrunkardSK.db.realm.nList[i].name.."--");
				if (UnitPlayerOrPetInRaid(DrunkardSK.db.realm.nList[i].name) == 1) then
					--DrunkardSK:Print("Swapping "..DrunkardSK.db.realm.nList[suicider].name.."and"..DrunkardSK.db.realm.nList[i].name);
					--swap selected with current
					local temp = DrunkardSK.db.realm.nList[i];
					DrunkardSK.db.realm.nList[i] = DrunkardSK.db.realm.nList[suicider];
					DrunkardSK.db.realm.nList[suicider] = temp;
					--set new suicider position
					suicider = i;
				end
			end
			DrunkardSK.db.realm.nStamp = DrunkardSK:CreateTimeStamp();
		end
	else
		if (current < DrunkardSK.db.realm.tLength) then
			for i=current, DrunkardSK.db.realm.tLength, 1 do
				if (UnitPlayerOrPetInRaid(DrunkardSK.db.realm.tList[i].name) == 1) then
					--swap selected with current
					local temp = DrunkardSK.db.realm.tList[i];
					DrunkardSK.db.realm.tList[i] = DrunkardSK.db.realm.tList[suicider];
					DrunkardSK.db.realm.tList[suicider] = temp;
					--set new suicider position
					suicider = i;
				end
			end
			DrunkardSK.db.realm.tStamp = DrunkardSK:CreateTimeStamp();
		end
	end
	DSKListFrame.selectedEntry = suicider;
end

--update scroll frame
local function ScrollList_Update()
	local entryOffset = FauxScrollFrame_GetOffset(ScrollList); 
	
	--set hightlight and up/down buttons on selected entry
	for i=1, 18, 1 do
		entryIndex = entryOffset + i;
		if ( entryIndex == DSKListFrame.selectedEntry ) then
			getglobal("entry"..i):LockHighlight();
			DSKListFrame.down:SetPoint('RIGHT', getglobal("entry"..i), 'RIGHT', -2, 0);
			DSKListFrame.down:Show();
			DSKListFrame.up:Show();
		else
			getglobal("entry"..i):UnlockHighlight();
		end
	end
	
	--if selected entry is not on screen hide up/down buttons	
	if (DSKListFrame.selectedEntry > entryOffset+18) or (DSKListFrame.selectedEntry <= entryOffset) then
		downButton:Hide();
		upButton:Hide();
	end
	
	--which tab is selected
	if(PanelTemplates_GetSelectedTab(DSKListFrame) == 1) then
		local line; -- 1 through 18 of our window to scroll
		local lineplusoffset; -- an index into our data calculated from the scroll offset
		--loop through and set names and colors in list
		for line=1,18 do
			lineplusoffset = line + FauxScrollFrame_GetOffset(ScrollList);
			if lineplusoffset <= DrunkardSK.db.realm.nLength then
				getglobal("entry"..line).text:SetText(lineplusoffset..". "..DrunkardSK.db.realm.nList[lineplusoffset].name);
				local color = RAID_CLASS_COLORS[DrunkardSK.db.realm.nList[lineplusoffset].class];
				if (UnitPlayerOrPetInRaid(DrunkardSK.db.realm.nList[line].name) == 1) then
					getglobal("entry"..line).text:SetTextColor(color.r, color.g, color.b);
				else
					getglobal("entry"..line).text:SetTextColor(0.5, 0.5, 0.5);
				end
				getglobal("entry"..line).text:Show();
			else
				getglobal("entry"..line).text:Hide();
			end
		end 
		
		--disable up/down if top/bottom entry selected
		if(DSKListFrame.selectedEntry == 1) and Master then
			upButton:Disable();
		elseif Master then
			upButton:Enable();
		end
		
		if(DSKListFrame.selectedEntry == DrunkardSK.db.realm.nLength) and Master then
			downButton:Disable();
		elseif Master then
			downButton:Enable();
		end
		
		if(DSKListFrame.selectedEntry > DrunkardSK.db.realm.nLength) and Master then
			downButton:Disable();
			upButton:Disable();
		end
		
		FauxScrollFrame_Update(ScrollList,DrunkardSK.db.realm.nLength,18,16);
	else
		local line; -- 1 through 18 of our window to scroll
		local lineplusoffset; -- an index into our data calculated from the scroll offset
		--loop through and set names and colors in list
		for line=1,18 do
			lineplusoffset = line + FauxScrollFrame_GetOffset(ScrollList);
			if lineplusoffset <= DrunkardSK.db.realm.tLength then
				getglobal("entry"..line).text:SetText(lineplusoffset..". "..DrunkardSK.db.realm.tList[lineplusoffset].name);
				local color = RAID_CLASS_COLORS[DrunkardSK.db.realm.tList[lineplusoffset].class];
				if (UnitPlayerOrPetInRaid(DrunkardSK.db.realm.tList[line].name) == 1) then
					getglobal("entry"..line).text:SetTextColor(color.r, color.g, color.b);
				else
					getglobal("entry"..line).text:SetTextColor(0.5, 0.5, 0.5);
				end
				getglobal("entry"..line).text:Show();
			else
				getglobal("entry"..line).text:Hide();
			end
		end
		
		--disable up/down if top/bottom entry selected
		if(DSKListFrame.selectedEntry == 1) and Master then
			upButton:Disable();
		elseif Master then
			upButton:Enable();
		end
		
		if(DSKListFrame.selectedEntry == DrunkardSK.db.realm.tLength) and Master then
			downButton:Disable();
		elseif Master then
			downButton:Enable();
		end
		
		if(DSKListFrame.selectedEntry > DrunkardSK.db.realm.tLength) and Master then
			downButton:Disable();
			upButton:Disable();
		end
		
		FauxScrollFrame_Update(ScrollList,DrunkardSK.db.realm.tLength,18,16);
	end
	--DEFAULT_CHAT_FRAME:AddMessage("We're at "..FauxScrollFrame_GetOffset(ScrollList));
end

--on Token tab click
local function ClickTTab()
	--DrunkardSK:Print('TTab')
	PlaySound("igCharacterInfoTab");
	PanelTemplates_SetTab(DSKListFrame, 2);
	DSKListFrame.title:SetText("Token List");
	DSKListFrame.selectedEntry = 0;
	ScrollList_Update();
end

--on Normal Tab click
local function ClickNTab()
	--DrunkardSK:Print('NTab')
	PlaySound("igCharacterInfoTab");
	PanelTemplates_SetTab(DSKListFrame, 1);
	DSKListFrame.title:SetText("Normal List");
	DSKListFrame.selectedEntry = 0;
	ScrollList_Update();
end

--on open list click
local function OpenListClick()
	ScrollList_Update()
	DSKListFrame:Show()
end

--on entry button click
local function EntrySelect(self)
	DSKListFrame.selectedEntry = FauxScrollFrame_GetOffset(ScrollList) + self:GetID()
	ScrollList_Update()
end

local function EntryClick(self, button, down)
	EntrySelect(self);
end

--on add button click
local function AddClick(self, button, down)
	if(PanelTemplates_GetSelectedTab(DSKListFrame) == 1) then
		if (UnitExists("target") == 1) and (UnitIsPlayer("target") == 1) then
			--DrunkardSK:Print("Add Click");
			if (DrunkardSK.db.realm.nLength == nil) then
				DrunkardSK.db.realm.nLength = 0;
			end
			if (DrunkardSK.db.realm.nList == nil) then
				DrunkardSK.db.realm.nList = {};
			end
			
			DrunkardSK.db.realm.nLength = DrunkardSK.db.realm.nLength + 1;
			--DrunkardSK:Print(DrunkardSK.db.realm.nLength);
			
			local _, englishClass = UnitClass("target");
			DrunkardSK.db.realm.nList[DrunkardSK.db.realm.nLength] = {name = UnitName("target"), class = englishClass};
			--DrunkardSK:Print(DrunkardSK.db.realm.nList[DrunkardSK.db.realm.nLength].name);
			--DrunkardSK:Print(DrunkardSK.db.realm.nList[DrunkardSK.db.realm.nLength].class);
			DrunkardSK.db.realm.nStamp = DrunkardSK:CreateTimeStamp();
		
		end
	else
		if (UnitExists("target") == 1) and (UnitIsPlayer("target") == 1) then
			--DrunkardSK:Print("Add Click");
			if (DrunkardSK.db.realm.tLength == nil) then
				DrunkardSK.db.realm.tLength = 0;
			end
			if (DrunkardSK.db.realm.tList == nil) then
				DrunkardSK.db.realm.tList = {};
			end
			
			DrunkardSK.db.realm.tLength = DrunkardSK.db.realm.tLength + 1;
			--DrunkardSK:Print(DrunkardSK.db.realm.nLength);
			
			local _, englishClass = UnitClass("target");
			DrunkardSK.db.realm.tList[DrunkardSK.db.realm.tLength] = {name = UnitName("target"), class = englishClass};
			--DrunkardSK:Print(DrunkardSK.db.realm.tList[DrunkardSK.db.realm.tLength].name);
			--DrunkardSK:Print(DrunkardSK.db.realm.tList[DrunkardSK.db.realm.tLength].class);
			DrunkardSK.db.realm.tStamp = DrunkardSK:CreateTimeStamp();
	
		end
	end
	ScrollList_Update();
end

--on up button click
local function UpClick(self, button, down)
	if(PanelTemplates_GetSelectedTab(DSKListFrame) == 1) then
		local temp = DrunkardSK.db.realm.nList[DSKListFrame.selectedEntry];
		DrunkardSK.db.realm.nList[DSKListFrame.selectedEntry] = DrunkardSK.db.realm.nList[DSKListFrame.selectedEntry-1];
		DrunkardSK.db.realm.nList[DSKListFrame.selectedEntry-1] = temp;
		DSKListFrame.selectedEntry = DSKListFrame.selectedEntry-1;
		DrunkardSK.db.realm.nStamp = DrunkardSK:CreateTimeStamp();
	else
		local temp = DrunkardSK.db.realm.tList[DSKListFrame.selectedEntry];
		DrunkardSK.db.realm.tList[DSKListFrame.selectedEntry] = DrunkardSK.db.realm.tList[DSKListFrame.selectedEntry-1];
		DrunkardSK.db.realm.tList[DSKListFrame.selectedEntry-1] = temp;
		DSKListFrame.selectedEntry = DSKListFrame.selectedEntry-1;
		DrunkardSK.db.realm.tStamp = DrunkardSK:CreateTimeStamp();
	end
	ScrollList_Update();
end

--on down button click
local function DownClick(self, button, down)
	if(PanelTemplates_GetSelectedTab(DSKListFrame) == 1) then
		local temp = DrunkardSK.db.realm.nList[DSKListFrame.selectedEntry];
		DrunkardSK.db.realm.nList[DSKListFrame.selectedEntry] = DrunkardSK.db.realm.nList[DSKListFrame.selectedEntry+1];
		DrunkardSK.db.realm.nList[DSKListFrame.selectedEntry+1] = temp;
		DSKListFrame.selectedEntry = DSKListFrame.selectedEntry+1;
		DrunkardSK.db.realm.nStamp = DrunkardSK:CreateTimeStamp();
	else
		local temp = DrunkardSK.db.realm.tList[DSKListFrame.selectedEntry];
		DrunkardSK.db.realm.tList[DSKListFrame.selectedEntry] = DrunkardSK.db.realm.tList[DSKListFrame.selectedEntry+1];
		DrunkardSK.db.realm.tList[DSKListFrame.selectedEntry+1] = temp;
		DSKListFrame.selectedEntry = DSKListFrame.selectedEntry+1;
		DrunkardSK.db.realm.tStamp = DrunkardSK:CreateTimeStamp();
	end
	ScrollList_Update();
end

--on delete button click
local function DeleteClick(self, button, down)
	if(DSKListFrame.selectedEntry ~= 0) then
		if(PanelTemplates_GetSelectedTab(DSKListFrame) == 1) then
			if(DrunkardSK.db.realm.nLength > 0) then			
				table.remove(DrunkardSK.db.realm.nList, DSKListFrame.selectedEntry)
				DrunkardSK.db.realm.nLength = DrunkardSK.db.realm.nLength - 1;
				DrunkardSK.db.realm.nStamp = DrunkardSK:CreateTimeStamp();
			end
		else		
			if(DrunkardSK.db.realm.tLength > 0) then
				table.remove(DrunkardSK.db.realm.tList, DSKListFrame.selectedEntry);
				DrunkardSK.db.realm.tLength = DrunkardSK.db.realm.tLength - 1;
				DrunkardSK.db.realm.tStamp = DrunkardSK:CreateTimeStamp();
			end
		end
		ScrollList_Update();
	end 
end

--close bid button click
local function CloseBidClick(self, button, down)
	if (HighName ~= "") then
		local list = DrunkardSK:WhichList();
		SendChatMessage(HighName.." wins "..ItemLink.."!", "RAID");
		Suicide(HighRank, list);
	elseif (HighRoller ~= "") then
		SendChatMessage(HighRoller.." wins "..ItemLink.."!", "RAID");
	end
	
	--reset everything
	HighRank = 5000;
	HighName = "";
	BidsReceived = 0;
	ItemLink = nil;
	BidList = {}
	OffspecList = {}
	OffspecCount = 0
	HighRoller = "" 
	HighRoll = 0
	
	DrunkardSK:SendCommMessage("DSKCloseBid", "cb", "RAID");
	
	ScrollList_Update();
end

--murder button click
local function MurderClick(self, button, down)
	local list;
	if (DSKListFrame.selectedEntry ~= 0) then
		if(PanelTemplates_GetSelectedTab(DSKListFrame) == 1) then
			list = "nList";
		else
			list = "tList";
		end
		--DrunkardSK:Print("murder "..DSKListFrame.selectedEntry.." "..list);
		Suicide(DSKListFrame.selectedEntry, list);
		ScrollList_Update();
	end 
end

--sync button click
local function SyncClick(self, button, down)
	if (Master) then
		--send sync req with master
		DrunkardSK:Print("Sync clicked master");
		DrunkardSK:SendCommMessage("DSKSyncReq", "master", "RAID");
	else
		--send sync req without master
		DrunkardSK:Print("Sync clicked not master");
		DrunkardSK:SendCommMessage("DSKSyncReq", "not master", "RAID");
	end
	--DrunkardSK:Print(DrunkardSK:Serialize(DrunkardSK.db.realm.nList));
end

--bid button click
local function BidClick(self, button, down)
	MyBidType = "bid";
	DrunkardSK:SendCommMessage("DSKSendBid", DrunkardSK:Serialize(MyBidType, UnitName("player")), "RAID");
	DSKBidFrame.offspec:Disable();
	DSKBidFrame.pass:Disable();
	DSKBidFrame.bid:Disable();
	DSKBidFrame.retract:Enable();
end

--offspec button click
local function OffspecClick(self, button, down)
	MyBidType = "offspec";
	DrunkardSK:SendCommMessage("DSKSendBid", DrunkardSK:Serialize(MyBidType, UnitName("player")), "RAID");
	DSKBidFrame.offspec:Disable();
	DSKBidFrame.pass:Disable();
	DSKBidFrame.bid:Disable();
	DSKBidFrame.retract:Enable();
end

--pass button click
local function PassClick(self, button, down)
	MyBidType = "pass";
	DrunkardSK:SendCommMessage("DSKSendBid", DrunkardSK:Serialize(MyBidType, UnitName("player")), "RAID");
	DSKBidFrame.offspec:Disable();
	DSKBidFrame.pass:Disable();
	DSKBidFrame.bid:Disable();
	DSKBidFrame.retract:Enable();
end

--retract button click
local function RetractClick(self, button, down)
	DrunkardSK:SendCommMessage("DSKSendRetract", DrunkardSK:Serialize(MyBidType, UnitName("player")), "RAID");
	DSKBidFrame.offspec:Enable();
	DSKBidFrame.pass:Enable();
	DSKBidFrame.bid:Enable();
	DSKBidFrame.retract:Disable();
end

--[[
	Loading/Profile Functions
--]]



function DrunkardSK:OnInitialize()
	local itemID = 40475
	local f = CreateFrame('Frame', 'DSKBidFrame', UIParent)
	f:Hide()
	
	f:SetWidth(350); 
	f:SetHeight(120);
	f:SetPoint("CENTER");
	f:SetBackdrop(DrunkardSK.bg)
	f:EnableMouse(true)
	f:SetToplevel(true)
	f:SetMovable(true)
	f:SetClampedToScreen(true)
	f:SetFrameStrata('DIALOG')
	f:SetScript('OnMouseDown', f.StartMoving)
	f:SetScript('OnMouseUp', f.StopMovingOrSizing)

	--title text
	f.text = f:CreateFontString(nil, 'OVERLAY', 'GameFontHighlight')
	f.text:SetText('<No High Bidder>')
	f.text:SetPoint('TOP', 0, -15)
	
	--item link
	f.link = CreateFrame('ScrollingMessageFrame', nil, f)
	f.link:SetWidth(290) 
	f.link:SetHeight(14)
	f.link:SetMaxLines(1)
	f.link:SetFontObject("GameFontNormal");
	f.link:EnableMouse(true)
	f.link:SetScript("OnHyperlinkClick", ChatFrame_OnHyperlinkShow)
	f.link:SetFading(false)
	f.link:SetPoint('CENTER', 0, -35)

	--item icon
	f.item = CreateFrame('Button', nil, f)
	f.item:SetNormalTexture(GetItemIcon(itemID))
	f.item:SetWidth(45); 
	f.item:SetHeight(45);
	f.item:EnableMouse(true)
	f.item:SetPoint('CENTER', 0, 0)
	
	--bid button
	f.bid = CreateFrame('Button', nil, f, "OptionsButtonTemplate")
	f.bid:SetText('Bid')
	f.bid:SetPoint('TOPLEFT', 30, -40)
	f.bid:SetScript('OnClick', BidClick)
	
	--pass button
	f.pass = CreateFrame('Button', nil, f, "OptionsButtonTemplate")
	f.pass:SetText('Pass')
	f.pass:SetPoint('TOPRIGHT', -30, -65)
	f.pass:SetScript('OnClick', PassClick)
	
	--offspec button
	f.offspec = CreateFrame('Button', nil, f, "OptionsButtonTemplate")
	f.offspec:SetText('Offspec')
	f.offspec:SetPoint('TOPRIGHT', -30, -40)
	f.offspec:SetScript('OnClick', OffspecClick)
	
	--retract button
	f.retract = CreateFrame('Button', nil, f, "OptionsButtonTemplate")
	f.retract:SetText('Retract')
	f.retract:SetPoint('TOPLEFT', 30, -65)
	f.retract:SetScript('OnClick', RetractClick)
	f.retract:Disable()
	
	--close button
	--f.close = CreateFrame('Button', nil, f, 'UIPanelCloseButton')
	--f.close:SetPoint('TOPRIGHT', -5, -5)
	
	--open list button
	f.openList = CreateFrame('Button', nil, f, 'UIPanelScrollDownButtonTemplate')
	f.openList:SetPoint('BOTTOMRIGHT', -12, 10)
	f.openList:EnableMouse(true)
	f.openList:SetScript("OnEnter", OpenListEnter)
	f.openList:SetScript("OnLeave", OpenListLeave)
	f.openList:SetScript("OnClick", OpenListClick)
	
	
	local l = CreateFrame('Frame', 'DSKListFrame', UIParent)
	l:Hide()
	
	l:SetWidth(250); 
	l:SetHeight(400);
	l:SetPoint("CENTER");
	l:SetBackdrop(DrunkardSK.bg)
	l:EnableMouse(true)
	l:SetToplevel(true)
	l:SetMovable(true)
	l:SetClampedToScreen(true)
	l:SetFrameStrata('DIALOG')
	l:SetScript('OnMouseDown', l.StartMoving)
	l:SetScript('OnMouseUp', l.StopMovingOrSizing)
	
	--listframe title
	l.title = l:CreateFontString(nil, 'OVERLAY', 'GameFontHighlight')
	l.title:SetText('Normal List')
	l.title:SetPoint('TOP', 0, -15)
	
	--close button
	l.close = CreateFrame('Button', nil, l, 'UIPanelCloseButton')
	l.close:SetPoint('TOPRIGHT', -5, -5)

	--normal list tab
	l.nTab = CreateFrame('Button', 'DSKListFrameTab1', l, "CharacterFrameTabButtonTemplate")
	l.nTab:SetPoint('CENTER', l, 'BOTTOMLEFT', 50, -10)
	l.nTab:SetID(1)
	l.nTab:SetText('Normal List')
	l.nTab:SetScript('OnClick', ClickNTab)
	
		
	--token list tab
	l.tTab = CreateFrame('Button', 'DSKListFrameTab2', l, "CharacterFrameTabButtonTemplate")
	l.tTab:SetPoint("LEFT", DSKListFrameTab1, "RIGHT", -14, 0);
	l.tTab:SetID(2)
	l.tTab:SetText('Token List')
	l.tTab:SetScript('OnClick', ClickTTab)

	--add button
	l.add = CreateFrame('Button', 'ListAddButton', l, "OptionsButtonTemplate")
	l.add:SetText('Add')
	l.add:SetPoint('TOPLEFT', 35, -28)
	l.add:SetScript('OnClick', AddClick)
	
	--delete button
	l.del = CreateFrame('Button', nil, l, "OptionsButtonTemplate")
	l.del:SetText('Delete')
	l.del:SetPoint('LEFT', ListAddButton, 'RIGHT', 0, 0)
	l.del:SetScript('OnClick', DeleteClick)
	
	--murder button
	l.murder = CreateFrame('Button', 'ListMurderButton', l, "OptionsButtonTemplate")
	l.murder:SetText('Murder')
	l.murder:SetPoint('BOTTOMLEFT', 35, 38)
	l.murder:SetScript('OnClick', MurderClick)
	
	--close bid button
	l.closeBid = CreateFrame('Button', nil, l, "OptionsButtonTemplate")
	l.closeBid:SetText('Close Bid')
	l.closeBid:SetPoint('BOTTOM', 0, 15)
	l.closeBid:SetScript('OnClick', CloseBidClick)
	
	--sync button
	l.sync = CreateFrame('Button', nil, l, "OptionsButtonTemplate")
	l.sync:SetText('Sync')
	l.sync:SetPoint('LEFT', ListMurderButton, 'RIGHT', 0, 0)
	l.sync:SetScript('OnClick', SyncClick)

	--down button
	l.down = CreateFrame('Button', 'downButton', l, 'UIPanelScrollDownButtonTemplate')
	l.down:SetPoint('RIGHT', entry1, 'RIGHT')
	l.down:SetFrameStrata('FULLSCREEN')
	l.down:SetScript('OnClick', DownClick)
	l.down:Hide()
	
	--up button
	l.up = CreateFrame('Button', 'upButton', l, 'UIPanelScrollUpButtonTemplate')
	l.up:SetPoint('RIGHT', downButton, 'LEFT')
	l.up:SetFrameStrata('FULLSCREEN')
	l.up:SetScript('OnClick', UpClick)
	l.up:Hide()	
	
	--scroll frame (actual list)
	l.list = CreateFrame('ScrollFrame', 'ScrollList', l, 'FauxScrollFrameTemplate')
	l.list:SetPoint('TOPLEFT', 10, -50)
	l.list:SetWidth(200); 
	l.list:SetHeight(288);
	--l.list:SetScript('OnShow', ScrollList_Update)
	l.list:SetScript('OnVerticalScroll', function(self, offset)
			FauxScrollFrame_OnVerticalScroll(self, offset, 16, ScrollList_Update);
			end)
	
	
	--entry buttons
	l.entry1 = CreateFrame('Button', 'entry1', l)
	l.entry1:SetPoint('TOPLEFT', ScrollList, 'TOPLEFT', 8, 0)
	l.entry1.text = l.entry1:CreateFontString('entry1_Text', 'BORDER','GameFontHighlightLeft')
	l.entry1.text:SetText('entry1')
	l.entry1.text:SetPoint('LEFT')
	l.entry1:SetWidth(200)
	l.entry1:SetHeight(16)
	l.entry1:SetHighlightTexture("Interface\\QuestFrame\\UI-QuestTitleHighlight", "ADD")
	l.entry1:EnableMouse(true)
	l.entry1:SetScript('OnClick', EntryClick)
	l.entry1:SetID(1)
	
	l.entry2 = CreateFrame('Button', 'entry2', l)
	l.entry2:SetPoint('TOPLEFT', entry1, 'BOTTOMLEFT')
	l.entry2.text = l.entry2:CreateFontString('entry2_Text', 'BORDER','GameFontHighlightLeft')
	l.entry2.text:SetText('entry2')
	l.entry2.text:SetPoint('LEFT')
	l.entry2:SetWidth(200)
	l.entry2:SetHeight(16)
	l.entry2:SetHighlightTexture("Interface\\QuestFrame\\UI-QuestTitleHighlight", "ADD")
	l.entry2:EnableMouse(true)
	l.entry2:SetScript('OnClick', EntryClick)
	l.entry2:SetID(2)
	
	l.entry3 = CreateFrame('Button', 'entry3', l)
	l.entry3:SetPoint('TOPLEFT', entry2, 'BOTTOMLEFT')
	l.entry3.text = l.entry3:CreateFontString('entry3_Text', 'BORDER','GameFontHighlightLeft')
	l.entry3.text:SetText('entry3')
	l.entry3.text:SetPoint('LEFT')
	l.entry3:SetWidth(200)
	l.entry3:SetHeight(16)
	l.entry3:SetHighlightTexture("Interface\\QuestFrame\\UI-QuestTitleHighlight", "ADD")
	l.entry3:EnableMouse(true)
	l.entry3:SetScript('OnClick', EntryClick)
	l.entry3:SetID(3)
	
	l.entry4 = CreateFrame('Button', 'entry4', l)
	l.entry4:SetPoint('TOPLEFT', entry3, 'BOTTOMLEFT')
	l.entry4.text = l.entry4:CreateFontString('entry4_Text', 'BORDER','GameFontHighlightLeft')
	l.entry4.text:SetText('entry4')
	l.entry4.text:SetPoint('LEFT')
	l.entry4:SetWidth(200)
	l.entry4:SetHeight(16)
	l.entry4:SetHighlightTexture("Interface\\QuestFrame\\UI-QuestTitleHighlight", "ADD")
	l.entry4:EnableMouse(true)
	l.entry4:SetScript('OnClick', EntryClick)
	l.entry4:SetID(4)
	
	l.entry5 = CreateFrame('Button', 'entry5', l)
	l.entry5:SetPoint('TOPLEFT', entry4, 'BOTTOMLEFT')
	l.entry5.text = l.entry5:CreateFontString('entry5_Text', 'BORDER','GameFontHighlightLeft')
	l.entry5.text:SetText('entry5')
	l.entry5.text:SetPoint('LEFT')
	l.entry5:SetWidth(200)
	l.entry5:SetHeight(16)
	l.entry5:SetHighlightTexture("Interface\\QuestFrame\\UI-QuestTitleHighlight", "ADD")
	l.entry5:EnableMouse(true)
	l.entry5:SetScript('OnClick', EntryClick)
	l.entry5:SetID(5)
	
	l.entry6 = CreateFrame('Button', 'entry6', l)
	l.entry6:SetPoint('TOPLEFT', entry5, 'BOTTOMLEFT')
	l.entry6.text = l.entry6:CreateFontString('entry6_Text', 'BORDER','GameFontHighlightLeft')
	l.entry6.text:SetText('entry6')
	l.entry6.text:SetPoint('LEFT')
	l.entry6:SetWidth(200)
	l.entry6:SetHeight(16)
	l.entry6:SetHighlightTexture("Interface\\QuestFrame\\UI-QuestTitleHighlight", "ADD")
	l.entry6:EnableMouse(true)
	l.entry6:SetScript('OnClick', EntryClick)
	l.entry6:SetID(6)
	
	l.entry7 = CreateFrame('Button', 'entry7', l)
	l.entry7:SetPoint('TOPLEFT', entry6, 'BOTTOMLEFT')
	l.entry7.text = l.entry7:CreateFontString('entry7_Text', 'BORDER','GameFontHighlightLeft')
	l.entry7.text:SetText('entry7')
	l.entry7.text:SetPoint('LEFT')
	l.entry7:SetWidth(200)
	l.entry7:SetHeight(16)
	l.entry7:SetHighlightTexture("Interface\\QuestFrame\\UI-QuestTitleHighlight", "ADD")
	l.entry7:EnableMouse(true)
	l.entry7:SetScript('OnClick', EntryClick)
	l.entry7:SetID(7)
	
	l.entry8 = CreateFrame('Button', 'entry8', l)
	l.entry8:SetPoint('TOPLEFT', entry7, 'BOTTOMLEFT')
	l.entry8.text = l.entry8:CreateFontString('entry8_Text', 'BORDER','GameFontHighlightLeft')
	l.entry8.text:SetText('entry8')
	l.entry8.text:SetPoint('LEFT')
	l.entry8:SetWidth(200)
	l.entry8:SetHeight(16)
	l.entry8:SetHighlightTexture("Interface\\QuestFrame\\UI-QuestTitleHighlight", "ADD")
	l.entry8:EnableMouse(true)
	l.entry8:SetScript('OnClick', EntryClick)
	l.entry8:SetID(8)
	
	l.entry9 = CreateFrame('Button', 'entry9', l)
	l.entry9:SetPoint('TOPLEFT', entry8, 'BOTTOMLEFT')
	l.entry9.text = l.entry9:CreateFontString('entry9_Text', 'BORDER','GameFontHighlightLeft')
	l.entry9.text:SetText('entry9')
	l.entry9.text:SetPoint('LEFT')
	l.entry9:SetWidth(200)
	l.entry9:SetHeight(16)
	l.entry9:SetHighlightTexture("Interface\\QuestFrame\\UI-QuestTitleHighlight", "ADD")
	l.entry9:EnableMouse(true)
	l.entry9:SetScript('OnClick', EntryClick)
	l.entry9:SetID(9)
	
	l.entry10 = CreateFrame('Button', 'entry10', l)
	l.entry10:SetPoint('TOPLEFT', entry9, 'BOTTOMLEFT')
	l.entry10.text = l.entry10:CreateFontString('entry10_Text', 'BORDER','GameFontHighlightLeft')
	l.entry10.text:SetText('entry10')
	l.entry10.text:SetPoint('LEFT')
	l.entry10:SetWidth(200)
	l.entry10:SetHeight(16)
	l.entry10:SetHighlightTexture("Interface\\QuestFrame\\UI-QuestTitleHighlight", "ADD")
	l.entry10:EnableMouse(true)
	l.entry10:SetScript('OnClick', EntryClick)
	l.entry10:SetID(10)
	
	l.entry11 = CreateFrame('Button', 'entry11', l)
	l.entry11:SetPoint('TOPLEFT', entry10, 'BOTTOMLEFT')
	l.entry11.text = l.entry11:CreateFontString('entry11_Text', 'BORDER','GameFontHighlightLeft')
	l.entry11.text:SetText('entry11')
	l.entry11.text:SetPoint('LEFT')
	l.entry11:SetWidth(200)
	l.entry11:SetHeight(16)
	l.entry11:SetHighlightTexture("Interface\\QuestFrame\\UI-QuestTitleHighlight", "ADD")
	l.entry11:EnableMouse(true)
	l.entry11:SetScript('OnClick', EntryClick)
	l.entry11:SetID(11)
	
	l.entry12 = CreateFrame('Button', 'entry12', l)
	l.entry12:SetPoint('TOPLEFT', entry11, 'BOTTOMLEFT')
	l.entry12.text = l.entry12:CreateFontString('entry12_Text', 'BORDER','GameFontHighlightLeft')
	l.entry12.text:SetText('entry12')
	l.entry12.text:SetPoint('LEFT')
	l.entry12:SetWidth(200)
	l.entry12:SetHeight(16)
	l.entry12:SetHighlightTexture("Interface\\QuestFrame\\UI-QuestTitleHighlight", "ADD")
	l.entry12:EnableMouse(true)
	l.entry12:SetScript('OnClick', EntryClick)
	l.entry12:SetID(12)
	
	l.entry13 = CreateFrame('Button', 'entry13', l)
	l.entry13:SetPoint('TOPLEFT', entry12, 'BOTTOMLEFT')
	l.entry13.text = l.entry13:CreateFontString('entry13_Text', 'BORDER','GameFontHighlightLeft')
	l.entry13.text:SetText('entry13')
	l.entry13.text:SetPoint('LEFT')
	l.entry13:SetWidth(200)
	l.entry13:SetHeight(16)
	l.entry13:SetHighlightTexture("Interface\\QuestFrame\\UI-QuestTitleHighlight", "ADD")
	l.entry13:EnableMouse(true)
	l.entry13:SetScript('OnClick', EntryClick)
	l.entry13:SetID(13)
	
	l.entry14 = CreateFrame('Button', 'entry14', l)
	l.entry14:SetPoint('TOPLEFT', entry13, 'BOTTOMLEFT')
	l.entry14.text = l.entry14:CreateFontString('entry14_Text', 'BORDER','GameFontHighlightLeft')
	l.entry14.text:SetText('entry14')
	l.entry14.text:SetPoint('LEFT')
	l.entry14:SetWidth(200)
	l.entry14:SetHeight(16)
	l.entry14:SetHighlightTexture("Interface\\QuestFrame\\UI-QuestTitleHighlight", "ADD")
	l.entry14:EnableMouse(true)
	l.entry14:SetScript('OnClick', EntryClick)
	l.entry14:SetID(14)
	
	l.entry15 = CreateFrame('Button', 'entry15', l)
	l.entry15:SetPoint('TOPLEFT', entry14, 'BOTTOMLEFT')
	l.entry15.text = l.entry15:CreateFontString('entry15_Text', 'BORDER','GameFontHighlightLeft')
	l.entry15.text:SetText('entry15')
	l.entry15.text:SetPoint('LEFT')
	l.entry15:SetWidth(200)
	l.entry15:SetHeight(16)
	l.entry15:SetHighlightTexture("Interface\\QuestFrame\\UI-QuestTitleHighlight", "ADD")
	l.entry15:EnableMouse(true)
	l.entry15:SetScript('OnClick', EntryClick)
	l.entry15:SetID(15)
	
	l.entry16 = CreateFrame('Button', 'entry16', l)
	l.entry16:SetPoint('TOPLEFT', entry15, 'BOTTOMLEFT')
	l.entry16.text = l.entry16:CreateFontString('entry16_Text', 'BORDER','GameFontHighlightLeft')
	l.entry16.text:SetText('entry16')
	l.entry16.text:SetPoint('LEFT')
	l.entry16:SetWidth(200)
	l.entry16:SetHeight(16)
	l.entry16:SetHighlightTexture("Interface\\QuestFrame\\UI-QuestTitleHighlight", "ADD")
	l.entry16:EnableMouse(true)
	l.entry16:SetScript('OnClick', EntryClick)
	l.entry16:SetID(16)
	
	l.entry17 = CreateFrame('Button', 'entry17', l)
	l.entry17:SetPoint('TOPLEFT', entry16, 'BOTTOMLEFT')
	l.entry17.text = l.entry17:CreateFontString('entry17_Text', 'BORDER','GameFontHighlightLeft')
	l.entry17.text:SetText('entry17')
	l.entry17.text:SetPoint('LEFT')
	l.entry17:SetWidth(200)
	l.entry17:SetHeight(16)
	l.entry17:SetHighlightTexture("Interface\\QuestFrame\\UI-QuestTitleHighlight", "ADD")
	l.entry17:EnableMouse(true)
	l.entry17:SetScript('OnClick', EntryClick)
	l.entry17:SetID(17)
	
	l.entry18 = CreateFrame('Button', 'entry18', l)
	l.entry18:SetPoint('TOPLEFT', entry17, 'BOTTOMLEFT')
	l.entry18.text = l.entry18:CreateFontString('entry18_Text', 'BORDER','GameFontHighlightLeft')
	l.entry18.text:SetText('entry18')
	l.entry18.text:SetPoint('LEFT')
	l.entry18:SetWidth(200)
	l.entry18:SetHeight(16)
	l.entry18:SetHighlightTexture("Interface\\QuestFrame\\UI-QuestTitleHighlight", "ADD")
	l.entry18:EnableMouse(true)
	l.entry18:SetScript('OnClick', EntryClick)
	l.entry18:SetID(18)
	
	--default disable master functions
	DSKListFrame.add:Disable();
	DSKListFrame.del:Disable();
	DSKListFrame.murder:Disable();
	DSKListFrame.up:Disable();
	DSKListFrame.down:Disable();
	DSKListFrame.closeBid:Disable();

	DSKListFrame.selectedEntry = 0;
	
	--setup tabs
	PanelTemplates_SetNumTabs(DSKListFrame, 2);
	PanelTemplates_TabResize(DSKListFrameTab1, 30)
	PanelTemplates_TabResize(DSKListFrameTab2, 30)
	PanelTemplates_SetTab(DSKListFrame, 1);

	--hooks
	DrunkardSK:SecureHook("HandleModifiedItemClick", "HandleModifiedItemClick")
	
	--register for events
	DrunkardSK:RegisterEvent("RAID_ROSTER_UPDATE")
	
	--slash command
	DrunkardSK:RegisterChatCommand("dsk", "OpenList")
	DrunkardSK:RegisterChatCommand("DSK", "OpenList")
	
	--comm setup
	DrunkardSK:RegisterComm("DSKOpenBid", "OpenBidding")
	DrunkardSK:RegisterComm("DSKSendBid", "ReceiveBid")
	DrunkardSK:RegisterComm("DSKNewHigh", "HighBidder")
	DrunkardSK:RegisterComm("DSKCloseBid", "CloseBid");
	DrunkardSK:RegisterComm("DSKSendRetract", "RetractBid");
	DrunkardSK:RegisterComm("DSKSyncReq", "ReceiveSyncReq");
	DrunkardSK:RegisterComm("DSKBroadcastList", "ReceiveBroadcast");
	DrunkardSK:RegisterComm("DSKSendList", "ReceiveList");
	
	--saved vars
	self.db = LibStub("AceDB-3.0"):New("DrunkardSKDB")
	
	if (DrunkardSK.db.realm.nLength == nil) then
		DrunkardSK.db.realm.nLength = 0;
	end
	if (DrunkardSK.db.realm.tLength == nil) then
		DrunkardSK.db.realm.tLength = 0;
	end
	
	if (DrunkardSK.db.realm.nStamp == nil) then
		DrunkardSK.db.realm.nStamp = 0;
	end
	if (DrunkardSK.db.realm.tStamp == nil) then
		DrunkardSK.db.realm.tStamp = 0;
	end
	
end

function DrunkardSK:OnEnable()
    -- Called when the addon is enabled
end

function DrunkardSK:OnDisable()
    -- Called when the addon is disabled
end

--is masterlooter and guild officer
function DrunkardSK:IsMaster()
	local _, master, _ = GetLootMethod();
	local _, _, officer = GetGuildInfo("player");
	
	if (master ~= nil) and (master == 0) and (officer <= 1) then
		--DrunkardSK:Print("true "..master.." "..officer);
		ret = true;
	else
		--DrunkardSK:Print("false "..officer);
		ret = false;
	end
	
	return ret;
end

--handle RAID_ROSTER_UPDATE event
function DrunkardSK:RAID_ROSTER_UPDATE()
	--DrunkardSK:Print("RAID_ROSTER_UPDATE fired!!!");
	if (DrunkardSK:IsMaster()) then
		DSKListFrame.add:Enable();
		DSKListFrame.del:Enable();
		DSKListFrame.murder:Enable();
		DSKListFrame.up:Enable();
		DSKListFrame.down:Enable();
		DSKListFrame.closeBid:Enable();
		Master = true;
	else
		DSKListFrame.add:Disable();
		DSKListFrame.del:Disable();
		DSKListFrame.murder:Disable();
		DSKListFrame.up:Disable();
		DSKListFrame.down:Disable();
		DSKListFrame.closeBid:Disable();
		Master = false;
	end
	ScrollList_Update();
end

--on loot item icon mouseover
local function IconEnter(self)
	GameTooltip:SetOwner(self, "ANCHOR_NONE")
    GameTooltip:SetPoint("BOTTOMRIGHT", self, "TOPLEFT")
    GameTooltip:SetHyperlink(ItemLink)
    GameTooltip:Show()
end

--no more loot item icon mouseover
local function IconLeave()
	GameTooltip:Hide()
end

--create list timestamp
function DrunkardSK:CreateTimeStamp()
	local _, hour, minute = GameTime_GetGameTime(false);
	local _, month, day, year = CalendarGetDate();
	if (hour < 10) then
		hour = "0"..hour;
	end
	if (minute < 10) then
		minute = "0"..minute;
	end
	if (day < 10) then
		day = "0"..day;
	end
	if (month < 10) then
		month = "0"..month;
	end
	--DrunkardSK:Print(year..month..day..hour..minute);
	return year..month..day..hour..minute;
end

--on dsk slash command
function DrunkardSK:OpenList(input)
  	ScrollList_Update();
	DSKListFrame:Show();
end

--set item being bid on
function DrunkardSK:SetOpenItem(item)
	local n, l, q, iL, reqL, t, subT, maxS, equipS, texture = GetItemInfo(item)
	DSKBidFrame.link:AddMessage(item)
	DSKBidFrame.item:SetNormalTexture(texture)
	DSKBidFrame.item:SetScript("OnEnter", IconEnter)
	DSKBidFrame.item:SetScript("OnLeave", IconLeave)
end

--find persons spot in table
function DrunkardSK:FindInTable(person, list)
	if (list == "nList") then
		for i=1, DrunkardSK.db.realm.nLength, 1 do
			--DrunkardSK:Print(DrunkardSK.db.realm.nList[i].name.." "..person);
			if (DrunkardSK.db.realm.nList[i].name == person) then
				--DrunkardSK:Print("Found "..DrunkardSK.db.realm.nList[i].name.." at "..i);
				ret = i;
			end
		end
	else
		for i=1, DrunkardSK.db.realm.tLength, 1 do
			--DrunkardSK:Print(DrunkardSK.db.realm.tList[i].name.." "..person);
			if (DrunkardSK.db.realm.tList[i].name == person) then
				--DrunkardSK:Print("Found "..DrunkardSK.db.realm.tList[i].name.." at "..i);
				ret = i;
			end
		end
	end
	return ret;
end

--open bid frame for everyone
function DrunkardSK:OpenBidding(prefix, message, distribution, sender)
	ItemLink = message;
	--DrunkardSK:Print(ItemLink);
	DrunkardSK:SetOpenItem(ItemLink);
	DSKBidFrame:Show();
	
end

--close bid frame on bid close
function DrunkardSK:CloseBid(prefix, message, distribution, sender)
	DSKBidFrame:Hide();
	DSKBidFrame.offspec:Enable();
	DSKBidFrame.pass:Enable();
	DSKBidFrame.bid:Enable();
	DSKBidFrame.retract:Disable();
	DSKBidFrame.text:SetText('<No High Bidder>');
	DSKBidFrame.text:SetTextColor(1, 1, 1);
end


--determine which list to use based on item
function DrunkardSK:WhichList()
	_, _, _, _, _, iType, iSubType, _, _, _ = GetItemInfo(ItemLink);
	--DrunkardSK:Print(iType.."--"..iSubType);
	if (iType == "Miscellaneous") and (iSubType == "Junk") then
		return "tList";
	else
		return "nList";
	end
end

--find high roller
function DrunkardSK:FindHighRoller()
	local roll = 0; 
	local name = "";
	local found = false;
	for i=1, OffspecCount, 1 do 
		--DrunkardSK:Print(i..OffspecList[i].name..OffspecList[i].roll);
		if (OffspecList[i].roll > roll) and (OffspecList[i].retracted == false) then
			roll = OffspecList[i].roll;
			name = OffspecList[i].name;
			found = true;
		end
	end
	if (found) then
		return name, roll;
	else
		return "", 0;
	end
end

--find roller by name
function DrunkardSK:RemoveRoller(name) 
	for i=1, OffspecCount, 1 do 
		if (OffspecList[i].name == name) then
			--table.remove(OffspecList, i);
			--OffspecCount = OffspecCount-1;
			--DrunkardSK:Print(name..roll);
			OffspecList[i].retracted = true;
		end
	end
	return name, roll;
end

--add a roller
function DrunkardSK:AddRoller(name)
	local found = false;
	local roll;
	for i=1, OffspecCount, 1 do 
		--DrunkardSK:Print(i..OffspecList[i].name..OffspecList[i].roll);
		if (OffspecList[i].name == name) and (OffspecList[i].retracted) then
			OffspecList[i].retracted = false;
			--OffspecCount = OffspecCount+1;
			roll = OffspecList[i].roll;
			found = true;
			--DrunkardSK:Print("added"..name..roll);
		end
	end
	--add to OffspecList
	if(found == false) then
		roll = math.random(1, 1000);
		OffspecCount = OffspecCount+1;
		OffspecList[OffspecCount] = {name = name, roll = roll, retracted = false}
	end
	return roll;
end

--update winner
function DrunkardSK:UpdateWinner()
	if (HighName ~= "") then
		--DrunkardSK:Print("NewHigh "..bidder..rank);
		local list = DrunkardSK:WhichList();
		local _, englishClass = UnitClass(HighName)
		DrunkardSK:SendCommMessage("DSKNewHigh", DrunkardSK:Serialize("Bid: "..HighRank..". "..HighName, englishClass), "RAID");
	elseif (HighRoller ~= "") then
		--HighRoller, HighRoll = DrunkardSK:FindHighRoller();
		local _, englishClass = UnitClass(HighRoller)
		--DrunkardSK:Print(HighRoller);
		--DrunkardSK:Print(englishClass);
		DrunkardSK:SendCommMessage("DSKNewHigh", DrunkardSK:Serialize("Offspec: "..HighRoller..": "..HighRoll, englishClass), "RAID");
	else
		DrunkardSK:SendCommMessage("DSKNewHigh", DrunkardSK:Serialize("<No High Bidder>", "PRIEST"), "RAID");
	end
end

--receive bid
function DrunkardSK:ReceiveBid(prefix, message, distribution, sender)
	if (Master) then
		local success, bidType, bidder = DrunkardSK:Deserialize(message);
		local list = DrunkardSK:WhichList();
		local rank = DrunkardSK:FindInTable(bidder, list);
		--DrunkardSK:Print(bidder..rank);
		BidsReceived = BidsReceived + 1;
		
		if (bidType == "bid") then
			--DrunkardSK:Print(bidder..bidType);
			table.insert(BidList, rank);
			table.sort(BidList);
			
			if (rank < HighRank) then
				HighRank = rank;
				HighName = bidder;
			end
		elseif (bidType == "offspec") then
			--DrunkardSK:Print(bidder..bidType);
			--gerenate random number 1-1000 and add to offspec list
			local roll = DrunkardSK:AddRoller(bidder);
			
			--display in raid chat
			SendChatMessage(bidder.." rolls "..roll.." (1-1000)" , "RAID");
			HighRoller, HighRoll = DrunkardSK:FindHighRoller();
		end
		
		DrunkardSK:UpdateWinner();
		
		if (BidsReceived == GetNumRaidMembers()) then
			DrunkardSK:Print("All bids received!");
		end
	end
end

--receive a request to sync
function DrunkardSK:ReceiveSyncReq(prefix, message, distribution, sender)
	local _, _, officer = GetGuildInfo("player");
	DrunkardSK:Print("ReceiveSyncReq - entered");
	if (message == "master") and (officer <= 1) and (Master == false) then
		DrunkardSK:Print("ReceiveSyncReq - sending DSKSendList");
		DrunkardSK:SendCommMessage("DSKSendList", DrunkardSK:Serialize(DrunkardSK.db.realm.nStamp, DrunkardSK.db.realm.nLength, DrunkardSK.db.realm.nList, DrunkardSK.db.realm.tStamp, DrunkardSK.db.realm.tLength, DrunkardSK.db.realm.tList), "RAID");
	elseif (message == "not master") and (Master) then
		DrunkardSK:Print("ReceiveSyncReq - sending DSKBroadcastList");
		DrunkardSK:SendCommMessage("DSKBroadcastList", DrunkardSK:Serialize(DrunkardSK.db.realm.nStamp, DrunkardSK.db.realm.nLength, DrunkardSK.db.realm.nList, DrunkardSK.db.realm.tStamp, DrunkardSK.db.realm.tLength, DrunkardSK.db.realm.tList), "RAID");
	end
end

--receive list broadcast from master
function DrunkardSK:ReceiveBroadcast(prefix, message, distribution, sender)
	local success, nstamp, nlength, nlist, tstamp, tlength, tlist = DrunkardSK:Deserialize(message);
	DrunkardSK:Print("ReceiveBroadcast - entered");
	if (Master == false) then
		DrunkardSK:Print("is "..nstamp.." bigger than "..DrunkardSK.db.realm.nStamp);
		if (tonumber(nstamp) > DrunkardSK.db.realm.nStamp) then
			DrunkardSK:Print("ReceiveBroadcast - updating nlist");
			DrunkardSK.db.realm.nStamp = tonumber(nstamp);
			DrunkardSK.db.realm.nLength = tonumber(nlength);
			DrunkardSK.db.realm.nList = nlist;
		end
		DrunkardSK:Print("is "..tstamp.." bigger than "..DrunkardSK.db.realm.tStamp);
		if (tonumber(tstamp) > DrunkardSK.db.realm.tStamp) then
			DrunkardSK:Print("ReceiveBroadcast - updating tlist");
			DrunkardSK.db.realm.tStamp = tonumber(tstamp);
			DrunkardSK.db.realm.tLength = tonumber(tlength);
			DrunkardSK.db.realm.tList = tlist;
		end
	end
	ScrollList_Update();
end

--master receive list updates from officers
function DrunkardSK:ReceiveList(prefix, message, distribution, sender)
	local success, nstamp, nlength, nlist, tstamp, tlength, tlist = DrunkardSK:Deserialize(message);
	DrunkardSK:Print("ReceiveList - entered");
	if (Master) then
		if (tonumber(nstamp) > DrunkardSK.db.realm.nStamp) then
			DrunkardSK:Print("ReceiveList - updating nlist");
			DrunkardSK.db.realm.nStamp = tonumber(nstamp);
			DrunkardSK.db.realm.nLength = tonumber(nlength);
			DrunkardSK.db.realm.nList = nlist;
		end
		if (tonumber(tstamp) > DrunkardSK.db.realm.tStamp) then
			DrunkardSK:Print("ReceiveList - updating tlist");
			DrunkardSK.db.realm.tStamp = tonumber(tstamp);
			DrunkardSK.db.realm.tLength = tonumber(tlength);
			DrunkardSK.db.realm.tList = tlist;
		end
	end
end

--retract bid
function DrunkardSK:RetractBid(prefix, message, distribution, sender)
	if (Master) then
		local success, bidType, bidder = DrunkardSK:Deserialize(message);
		
		BidsReceived = BidsReceived - 1;
		
		if(bidType == "bid") then
			local list = DrunkardSK:WhichList();
			local rank = DrunkardSK:FindInTable(bidder, list);
			table.remove(BidList, rank);
			table.sort(BidList);
			SendChatMessage(bidder.." has retracted their bid." , "RAID");
			
			if(BidList[1] ~= nil) then
				--DrunkardSK:Print("empty list");
				HighRank = BidList[1];
				local list = DrunkardSK:WhichList();
				if(list == "nList") then
					HighName = DrunkardSK.db.realm.nList[HighRank].name;
				else
					HighName = DrunkardSK.db.realm.tList[HighRank].name;
				end
			else
				HighRank = 5000;
				HighName = "";
			end
		elseif (bidType == "offspec") then
			DrunkardSK:RemoveRoller(bidder);
			SendChatMessage(bidder.." has retracted their roll." , "RAID");
		elseif (bidType == "pass") then
			SendChatMessage(bidder.." has retracted their pass." , "RAID");
		end
		DrunkardSK:UpdateWinner();
	end
end

--update high bidder
function DrunkardSK:HighBidder(prefix, message, distribution, sender)
	--DrunkardSK:Print("New High bidder received");
	local success, text, class = DrunkardSK:Deserialize(message);
	local color = RAID_CLASS_COLORS[class];
	DSKBidFrame.text:SetText(text);
	DSKBidFrame.text:SetTextColor(color.r, color.g, color.b);
end

--hook alt clicks to open bid
function DrunkardSK:HandleModifiedItemClick(item)
	--DrunkardSK:Print('handling modified clicks')
	--DrunkardSK:Print(item)
	if (Master) then
		if (IsAltKeyDown() and 
			not IsShiftKeyDown() and 
				not IsControlKeyDown()) then
			ItemLink = item;
			DrunkardSK:SendCommMessage("DSKOpenBid", ItemLink, "RAID");
			--DrunkardSK:OpenBidding(ItemLink)
		end
	end
end


